require 'cocoapods'
module QCloudHive
  class HiveSpec
    attr_accessor :name
    attr_accessor :path
    attr_accessor :branch
    attr_accessor :commit
    attr_accessor :sourceURL
    def initialize(name=nil, path=nil)
      @name = name
      @path = path
      @podspec = nil
    end
  
    def podspec
      if @podspec.nil?
        @podspec = Pod::Specification.from_file(path)
      end
      return @podspec
    end
    def toConfig
      config = "[#{name}]\n"
      if not path.nil?
        config += "path=#{path}\n"
      end
      if not commit.nil?
        config += "commit=#{commit}\n"
      end
      if not branch.nil?
        config += "branch=#{branch}\n"
      end
      if not sourceURL.nil?
        config += "sourceURL=#{sourceURL}\n"
      end
      config
    end

    def writeJson
      jsonPath = @path + ".json"
      File.open("#{jsonPath}", "w") { |f|
        f.write podspec.to_json
      }
    end
  end
end
